#undef		DEBUG

#include	<stdio.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sys/param.h>
#include	<sys/filsys.h>
#include	<ustat.h>
#include	<mnttab.h>
#include	<fcntl.h>
#ifdef DEBUG
#include	<errno.h>
#endif

int	flags = 0x000;
#define	TFLAG	0x001
#define	FFLAG	0x002
#define	VFLAG	0x004
#define	IFLAG	0x008

char *sccsid = "@(#)df.c 1.3 90/10/30";

main(argc,argv)
int	argc;
char	**argv;
{
	extern	char	*optarg;
	extern	int	optind;

	int	opt;
	char	*wantfs = NULL;
	FILE	*mntfp;
	struct	mnttab	mnttab[NMOUNT];
	int	nmount = 0;
	int	i;
	char	devnam[200];

	while(!flags && (((opt = getopt(argc,argv,"tfvi")) != EOF))) {
		switch(opt) {
		case '?':
			fprintf(stderr,"df: illegal arg -%c\n",opt);
			exit(-1);
			break;
		case 't':
			flags =  TFLAG;
			break;
		case 'f':
			flags =  FFLAG;
			break;
		case 'v':
			flags =  VFLAG;
			break;
		case 'i':
			flags =  IFLAG;
			break;
		}
	}
	if (optind < argc) wantfs = argv[optind];

#ifdef DEBUG
	if (wantfs) printf("Arg: %s\n",wantfs);
#endif

	if ((mntfp = fopen(PNMNTTAB, "r")) == NULL) {
		fprintf(stderr,"df: cannot open mount table\n");
		exit(1);
	}

	while (fread(&mnttab[nmount], sizeof(struct mnttab), 1, mntfp) == 1) {
		if (*mnttab[nmount].mt_filsys && *mnttab[nmount].mt_dev) nmount++;
	}
	fclose(mntfp);

	sync();

#ifdef DEBUG
	for(i=0; i<nmount; i++) {
		printf("mt_dev=\"%s\", mt_filsys=\"%s\", mt_ro_flg=\"%x\"\n",
			mnttab[i].mt_dev,
			mnttab[i].mt_filsys,
			mnttab[i].mt_ro_flg
		);
	}
#endif
	/* check any wantfs */
	switch(flags) {
	case IFLAG:
		printf("Mount Dir   Filesystem  iused	ifree	%%iused\n");
		break;
	case VFLAG:
		printf("Mount Dir   Filesystem  blocks	  used	  free	%% used\n");
		break;
	}

	if (wantfs) {
		for (i=0; i<nmount; i++) {
			sprintf(devnam,"/dev/%s",mnttab[i].mt_dev);
			if (!strcmp(devnam,wantfs)) break;
		}
		if (nmount == i) {
			fprintf(stderr,"df: %s not block special\n",wantfs);
			exit(1);
		}
		df(devnam,mnttab[i].mt_filsys);
	} else {
		for (i=0; i<nmount; i++) {
			sprintf(devnam,"/dev/%s",mnttab[i].mt_dev);
			df(devnam,mnttab[i].mt_filsys);
		}
	}
	exit(0);
}

df(device,filesys)
char *device, *filesys;
{
	struct	filsys	*sblk;
	long		blocks, inodes;
	extern struct filsys *getfs();

	if (!(sblk = getfs(device))) {
		exit(0);
	}

#ifdef DEBUG
	printf("%s: %s\n",
		device,
		sblk->s_fname
	);
	fflush(stdout);
	printf("%s: InodeSize: %d, Blocks: %d (Free: %d blocks, %d inodes)\n",
		device,
		sblk->s_isize,
		sblk->s_fsize,
		sblk->s_tfree,
		sblk->s_tinode
	);
	fflush(stdout);
#endif
	blocks = 2*sblk->s_tfree;
	inodes = sblk->s_tinode;

	switch(flags) {
	case TFLAG:
	default:
	case FFLAG:
		printf("%-8.8s(%-10.10s): %8d blocks", filesys, device, blocks);
		if (!(flags & FFLAG)) printf("%8d i-nodes", inodes);
		printf("\n");
		if (flags & TFLAG) {
			printf("%-21.21s(%8d total blocks,%5d for i-nodes)\n",
				" ",sblk->s_fsize*2,sblk->s_isize*2);
		}
		break;
	case VFLAG:
	case IFLAG:
		printf("%-12.12s%-10.10s",filesys,device);
		if (flags & VFLAG) {
			printf("%8d%8d%8d    %3d%%\n",
				sblk->s_fsize * 2,
				sblk->s_fsize * 2 - blocks,
				blocks,
				100-((int)((100 * blocks)/(sblk->s_fsize * 2)))
			);
		} else { /* IFLAG */
			printf("%7d%8d     %3d%%\n",
				(sblk->s_isize * 16) - inodes - 32,
				inodes,
				100-((int)((100 * inodes)/((sblk->s_isize * 16) -32)))
			);
		}
		break;
	}
}
